'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _omit2 = require('lodash/omit');

var _omit3 = _interopRequireDefault(_omit2);

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _theme = require('../../utils/theme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StyledButton = (0, _styledComponents2.default)('button').withConfig({
  displayName: 'Button__StyledButton'
})(['height:36px;min-width:90px;padding:0 12px;border:0;outline:none;box-shadow:', ';background:', ';color:', ';font-size:', ';cursor:', ';border-radius:', ';&:hover{transition:color 0.3s ease;background:', ';color:', ';}'], function (props) {
  return props.styled.selected ? props.theme.boxShadow.selected : props.theme.boxShadow.light;
}, (0, _theme.fromAtoms)('Button', 'styled.type', 'background'), (0, _theme.fromAtoms)('Button', 'styled.type', 'color'), function (props) {
  return props.theme.fontSizes.small;
}, function (props) {
  return props.disabled ? 'not-allowed' : 'pointer';
}, function (props) {
  return props.theme.borderRadius.soft;
}, (0, _theme.fromAtoms)('Button', 'styled.type', 'hoverBackground'), (0, _theme.fromAtoms)('Button', 'styled.type', 'hoverColor'));

/**
 * A button that will run a callback on click
 * ```javascript
 *  <Button onClick={alert} text="Submit" />
 * ```
 */

var Button = function (_React$PureComponent) {
  _inherits(Button, _React$PureComponent);

  function Button() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Button);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Button.__proto__ || Object.getPrototypeOf(Button)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function (e) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          disabled = _this$props.disabled,
          text = _this$props.text;


      if (onClick && !disabled) {
        onClick(e, text);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Button, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          text = _props.text,
          primary = _props.primary,
          danger = _props.danger,
          selected = _props.selected,
          disabled = _props.disabled,
          otherProps = _objectWithoutProperties(_props, ['children', 'text', 'primary', 'danger', 'selected', 'disabled']);

      var buttonProps = (0, _omit3.default)(otherProps, ['onClick']);

      return _react2.default.createElement(
        StyledButton,
        _extends({
          disabled: disabled,
          onClick: this.handleClick,
          styled: {
            selected: selected,
            type: disabled && 'disabled' || primary && 'primary' || danger && 'danger' || 'default'
          }
        }, buttonProps),
        children || text
      );
    }
  }]);

  return Button;
}(_react2.default.PureComponent);

Button.propTypes = {
  /**
   * Callback that will be run when the button is clicked.
   */
  onClick: _propTypes2.default.func,
  /**
   * Text that will be used as the button label.
   * If this props is provided, it will be passed back to the `onClick` handler
   */
  text: _propTypes2.default.string,
  /**
   * Disable the button.
   */
  disabled: _propTypes2.default.bool,
  /**
   * Render the button in blue700 (useful for CTAs)
   */
  primary: _propTypes2.default.bool,
  /**
   * Add styling to show the button as selected
   */
  selected: _propTypes2.default.bool,
  /**
   * Turn the button red to indicate something bad might happen
   */
  danger: _propTypes2.default.bool,
  /**
   * The type of button, as it relates to <form> components
   */
  type: _propTypes2.default.string
};

Button.defaultProps = {
  text: 'Submit',
  type: 'submit',
  disabled: false,
  primary: false,
  danger: false,
  selected: false,
  onClick: _noop3.default
};

exports.default = Button;