'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _partialRight2 = require('lodash/partialRight');

var _partialRight3 = _interopRequireDefault(_partialRight2);

var _first2 = require('lodash/first');

var _first3 = _interopRequireDefault(_first2);

var _get2 = require('lodash/get');

var _get3 = _interopRequireDefault(_get2);

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _orderBy2 = require('lodash/orderBy');

var _orderBy3 = _interopRequireDefault(_orderBy2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _polished = require('polished');

var _compose = require('../../utils/compose');

var _Header = require('./_Header');

var _Header2 = _interopRequireDefault(_Header);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var borderColor = function borderColor(props) {
  return (0, _polished.transparentize)(0.6, props.theme.colors.purple100);
};

var Styled = function Styled(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: 'DataTable'
  })(['border-collapse:collapse;width:100%;table-layout:fixed;td{padding:10px 8px;vertical-align:top;border-left:1px solid ', ';}thead td{border:0;font-weight:bold;}thead,tbody{border-bottom:1px solid ', ';border-left:3px solid transparent;}'], borderColor, borderColor);
};

// Split this into a helper to keep the `doSort` method consistent with the initial state `sort`.
var sort = function sort(data, key, order) {
  return (0, _orderBy3.default)(data, key, [order]);
};

/**
 *  A sortable table for showing large data sets.
 *  ```javascript
 *
 *  const data = [
 *  {
 *    name: 'Bob',
 *    email: 'a@weave.works',
 *  },
 *  {
 *    name: 'Albert',
 *    email: 'b@weave.works',
 *  },
 * ];
 *
 *  React.render(
 *   <DataTable
 *    data={data}
 *    columns={[{ value: 'name', label: 'Name' }, { value: 'email', label: 'Email' }]}
 *   >
 *    {rows =>
 *      map(rows, r => (
 *        <tr key={r.email}>
 *          <td>{r.name}</td>
 *          <td>{r.email}</td>
 *        </tr>
 *      ))
 *    }
 *   </DataTable>
 * )
 * ```
 *
 * #### Nested table
 * ```javascript
 * const nesteData = [
 *   {
 *     workloadId: 'default:deployment/myworkload',
 *     containers: [
 *       { name: 'nginx', behind: '4' },
 *       { name: 'redis', behind: '1' },
 *       { name: 'envoy', behind: '2' },
 *     ],
 *   },
 *   {
 *     workloadId: 'default:deployment/helloworld',
 *     containers: [{ name: 'helloworld', behind: '2' }],
 *   },
 *  ];
 *
 *  <DataTable
 *   nested
 *   data={nesteData}
 *   sortBy="workloadId"
 *   sortOrder="asc"
 *   columns={[
 *     { value: 'workloadId', label: 'Workload' },
 *     { value: 'containers', label: 'Containers' },
 *     { value: 'behind', label: 'Behind' },
 *   ]}
 *   sortOverrides={{ behind: row => max(map(row.containers, c => c.behind)) }}
 * >
 *   {rows =>
 *     map(rows, r => (
 *       <tbody key={r.workloadId}>
 *         {map(r.containers, (c, i) => (
 *           <tr key={c.name}>
 *             {i === 0 && <td rowSpan={r.containers.length}>{r.workloadId}</td>}
 *             <td>{c.name}</td>
 *             <td>{c.behind}</td>
 *           </tr>
 *         ))}
 *       </tbody>
 *     ))
 *   }
 * </DataTable>
 * ```
 *
 */

var DataTable = function (_React$PureComponent) {
  _inherits(DataTable, _React$PureComponent);

  function DataTable() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DataTable);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DataTable.__proto__ || Object.getPrototypeOf(DataTable)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      sortField: _this.props.sortBy || (0, _get3.default)((0, _first3.default)(_this.props.columns), 'value'),
      sortOrder: _this.props.sortOrder,
      sortedData: sort(_this.props.data, _this.props.sortBy, _this.props.sortOrder)
    }, _this.doSort = function (data, sortField) {
      var sortOrder = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 'asc';
      var sortOverrides = _this.props.sortOverrides;


      _this.setState({
        sortField: sortField,
        sortOrder: sortOrder,
        sortedData:
        // User overrides if specified, else do the default sort
        sortOverrides && sortOverrides[sortField] ? (0, _orderBy3.default)(data, (0, _partialRight3.default)(sortOverrides[sortField], sortOrder), sortOrder) : sort(data, sortField, sortOrder)
      });
    }, _this.handleHeaderClick = function (ev, columnValue) {
      var order = void 0;
      var field = _this.state.sortField;
      var column = _this.props.columns.find(function (c) {
        return c.value === columnValue;
      });

      var isCurrentColumn = columnValue === _this.state.sortField;
      if (isCurrentColumn) {
        // If we are already sorting by this column, change the order.
        order = _this.state.sortOrder === 'asc' ? 'desc' : 'asc';
      } else {
        // Else, order by the new column, ascending
        order = column.initialSortOrder || 'asc';
        field = columnValue;
      }

      _this.doSort(_this.state.sortedData, field, order);
      _this.props.onSort(field, order);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DataTable, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.doSort(this.state.sortedData, this.state.sortField, this.state.sortOrder);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _state = this.state,
          sortOrder = _state.sortOrder,
          sortField = _state.sortField;

      var field = sortField;
      var order = sortOrder;

      if (nextProps !== this.props) {
        // Only translate if props have *actually* changed.
        if (nextProps.sortBy !== this.props.sortBy || nextProps.sortOrder !== this.props.sortOrder) {
          field = nextProps.sortBy;
          order = nextProps.sortOrder;
        }
        this.doSort(nextProps.data, field, order);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          children = _props.children,
          columns = _props.columns,
          nested = _props.nested,
          extraHeaders = _props.extraHeaders;
      var _state2 = this.state,
          sortedData = _state2.sortedData,
          sortOrder = _state2.sortOrder,
          sortField = _state2.sortField;


      return _react2.default.createElement(
        'table',
        { className: className },
        _react2.default.createElement(
          'thead',
          null,
          _react2.default.createElement(
            'tr',
            null,
            (0, _map3.default)(columns, function (_ref2) {
              var value = _ref2.value,
                  label = _ref2.label,
                  sortable = _ref2.sortable,
                  width = _ref2.width,
                  element = _ref2.element;
              return _react2.default.createElement(
                _Header2.default,
                {
                  sortable: sortable,
                  order: sortField === value ? sortOrder : null,
                  value: value,
                  onClick: _this2.handleHeaderClick,
                  key: value,
                  width: width,
                  title: label
                },
                element || label
              );
            }),
            (0, _map3.default)(extraHeaders, function (h, i) {
              return _react2.default.createElement(
                'th',
                { key: i },
                h
              );
            })
          )
        ),
        nested ? children(sortedData) : _react2.default.createElement(
          'tbody',
          null,
          children(sortedData)
        )
      );
    }
  }]);

  return DataTable;
}(_react2.default.PureComponent);

var columnPropType = _propTypes2.default.shape({
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  label: _propTypes2.default.string,
  sortable: _propTypes2.default.bool,
  initialSortOrder: _propTypes2.default.oneOf(['asc', 'desc']),
  width: _propTypes2.default.string,
  element: _propTypes2.default.element
});

DataTable.propTypes = {
  /**
   * The rows that will be sorted by clicking on the headers.
   * There must be a key in your row object that matches the column `value`.
   */
  data: _propTypes2.default.arrayOf(_propTypes2.default.object).isRequired,
  /**
   * A render-prop function that will be passed the sorted rows for the table.
   */
  children: _propTypes2.default.func.isRequired,
  /**
   * An array of objects that will be used as columns.
   * `value` must map to a key in your data in order for sorting to work.
   * If an `element` key is specified, that element will be used instead of `label`.
   */
  columns: _propTypes2.default.arrayOf(columnPropType).isRequired,
  /**
   * The value by which to sort the rows passed to the `data` prop.
   */
  sortBy: _propTypes2.default.string,
  /**
   * Whether to sort by 'asc' or 'desc' on initial load.
   * Modifying this prop will override the user's currently selected sort order.
   */
  sortOrder: _propTypes2.default.oneOf(['asc', 'desc']),
  /**
   * A map of customer sorting functions that will be used when a column is sorted.
   * They keys of this object should match the colum `values` that to which you wish to
   * provide customer sorting logic.
   *
   */
  sortOverrides: _propTypes2.default.object,
  /**
   * If true, a wrapping `<tbody />` element will NOT be rendered.
   * All child rows of `nested` tables should be <tbody /> tags
   */
  nested: _propTypes2.default.bool,
  /**
   * Extra elements that will be added to the table headers.
   * These columns will NOT be sortable.
   */
  extraHeaders: _propTypes2.default.arrayOf(_propTypes2.default.element),
  /**
   * Optional callback triggered when a header is clicked.
   */
  onSort: _propTypes2.default.func
};

DataTable.defaultProps = {
  sortOrder: 'asc',
  sortOverrides: {},
  nested: false,
  extraHeaders: [],
  sortBy: '',
  onSort: _noop3.default
};

exports.default = (0, _compose.copyPropTypes)(DataTable, Styled(DataTable));