'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shapes = exports.nodeBaseSize = undefined;

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _keys2 = require('lodash/keys');

var _keys3 = _interopRequireDefault(_keys2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _templateObject = _taggedTemplateLiteral(['\n  color: ', ';\n  font-size: ', ';\n  margin-top: 4px;\n'], ['\n  color: ', ';\n  font-size: ', ';\n  margin-top: 4px;\n']),
    _templateObject2 = _taggedTemplateLiteral(['\n  color: ', ';\n  font-size: ', ';\n  margin-top: -7px;\n'], ['\n  color: ', ';\n  font-size: ', ';\n  margin-top: -7px;\n']);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _polished = require('polished');

var _MatchedText = require('../MatchedText');

var _MatchedText2 = _interopRequireDefault(_MatchedText);

var _ShapeCircle = require('./shapes/_ShapeCircle');

var _ShapeCircle2 = _interopRequireDefault(_ShapeCircle);

var _ShapeTriangle = require('./shapes/_ShapeTriangle');

var _ShapeTriangle2 = _interopRequireDefault(_ShapeTriangle);

var _ShapeSquare = require('./shapes/_ShapeSquare');

var _ShapeSquare2 = _interopRequireDefault(_ShapeSquare);

var _ShapePentagon = require('./shapes/_ShapePentagon');

var _ShapePentagon2 = _interopRequireDefault(_ShapePentagon);

var _ShapeHexagon = require('./shapes/_ShapeHexagon');

var _ShapeHexagon2 = _interopRequireDefault(_ShapeHexagon);

var _ShapeHeptagon = require('./shapes/_ShapeHeptagon');

var _ShapeHeptagon2 = _interopRequireDefault(_ShapeHeptagon);

var _ShapeOctagon = require('./shapes/_ShapeOctagon');

var _ShapeOctagon2 = _interopRequireDefault(_ShapeOctagon);

var _ShapeCloud = require('./shapes/_ShapeCloud');

var _ShapeCloud2 = _interopRequireDefault(_ShapeCloud);

var _ShapeSheet = require('./shapes/_ShapeSheet');

var _ShapeSheet2 = _interopRequireDefault(_ShapeSheet);

var _ShapeCylinder = require('./shapes/_ShapeCylinder');

var _ShapeCylinder2 = _interopRequireDefault(_ShapeCylinder);

var _ShapeDottedCylinder = require('./shapes/_ShapeDottedCylinder');

var _ShapeDottedCylinder2 = _interopRequireDefault(_ShapeDottedCylinder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

var nodeBaseSize = exports.nodeBaseSize = 55;
var shapes = exports.shapes = {
  circle: _ShapeCircle2.default,
  triangle: _ShapeTriangle2.default,
  square: _ShapeSquare2.default,
  pentagon: _ShapePentagon2.default,
  hexagon: _ShapeHexagon2.default,
  heptagon: _ShapeHeptagon2.default,
  octagon: _ShapeOctagon2.default,
  cloud: _ShapeCloud2.default,
  sheet: _ShapeSheet2.default,
  cylinder: _ShapeCylinder2.default,
  dottedcylinder: _ShapeDottedCylinder2.default
};

var labelWidth = nodeBaseSize * 2.5;

var GraphNodeWrapper = _styledComponents2.default.g.withConfig({
  displayName: '_GraphNodeStatic__GraphNodeWrapper'
})(['cursor:', ';'], function (props) {
  return props.cursorType;
});

var SvgTextContainer = _styledComponents2.default.g.attrs({
  transform: function transform(props) {
    return 'translate(0, ' + (props.y + 85) + ')';
  }
}).withConfig({
  displayName: '_GraphNodeStatic__SvgTextContainer'
})(['pointer-events:all;']);

var LabelSvg = _styledComponents2.default.text.attrs({
  fill: function fill(props) {
    return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple800;
  },
  textAnchor: 'middle',
  y: -38
}).withConfig({
  displayName: '_GraphNodeStatic__LabelSvg'
})(['font-size:', ';'], function (props) {
  return props.theme.fontSizes.normal;
});

var LabelMinorSvg = _styledComponents2.default.text.attrs({
  fill: function fill(props) {
    return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple600;
  },
  textAnchor: 'middle',
  y: -20
}).withConfig({
  displayName: '_GraphNodeStatic__LabelMinorSvg'
})(['font-size:', ';'], function (props) {
  return props.theme.fontSizes.small;
});

var LabelsStandardContainer = _styledComponents2.default.div.withConfig({
  displayName: '_GraphNodeStatic__LabelsStandardContainer'
})(['']);

var LabelTemplate = _styledComponents2.default.div.withConfig({
  displayName: '_GraphNodeStatic__LabelTemplate'
})(['background-color:', ';border-radius:', ';overflow:hidden;text-overflow:ellipsis;display:inline-block;text-align:center;padding:2px 10px;max-width:100%;pointer-events:all;', ';'], function (props) {
  return (0, _polished.transparentize)(0.2, props.contrastMode ? props.theme.colors.white : props.theme.colors.purple25);
}, function (props) {
  return props.theme.borderRadius.soft;
}, function (props) {
  return !props.highlighted && '\n      white-space: nowrap;\n    ';
});

var LabelStandard = LabelTemplate.extend(_templateObject, function (props) {
  return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple800;
}, function (props) {
  return props.theme.fontSizes.normal;
});

var LabelMinorStandard = LabelTemplate.extend(_templateObject2, function (props) {
  return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple600;
}, function (props) {
  return props.theme.fontSizes.small;
});

var GraphNodeStatic = function (_React$PureComponent) {
  _inherits(GraphNodeStatic, _React$PureComponent);

  function GraphNodeStatic() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, GraphNodeStatic);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = GraphNodeStatic.__proto__ || Object.getPrototypeOf(GraphNodeStatic)).call.apply(_ref, [this].concat(args))), _this), _this.findFirstSearchMatch = function (searchTerms, text) {
      var match = null;
      searchTerms.forEach(function (term) {
        var start = text.search(term);
        if ((0, _isEmpty3.default)(match) && start !== -1) {
          match = { start: start, length: term.length };
        }
      });
      return match;
    }, _this.handleMouseEnter = function (ev) {
      _this.props.onMouseEnter(_this.props.id, ev);
    }, _this.handleMouseLeave = function (ev) {
      _this.props.onMouseLeave(_this.props.id, ev);
    }, _this.handleClick = function (ev) {
      _this.props.onClick(_this.props.id, ev);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(GraphNodeStatic, [{
    key: 'renderSvgLabels',
    value: function renderSvgLabels() {
      return _react2.default.createElement(
        SvgTextContainer,
        { y: this.props.labelOffset },
        _react2.default.createElement(
          LabelSvg,
          { contrastMode: this.props.contrastMode },
          this.props.label
        ),
        _react2.default.createElement(
          LabelMinorSvg,
          { contrastMode: this.props.contrastMode },
          this.props.labelMinor
        )
      );
    }
  }, {
    key: 'renderStandardLabels',
    value: function renderStandardLabels() {
      var _props = this.props,
          label = _props.label,
          labelMinor = _props.labelMinor,
          highlighted = _props.highlighted,
          contrastMode = _props.contrastMode,
          labelOffset = _props.labelOffset,
          searchTerms = _props.searchTerms;


      return _react2.default.createElement(
        'foreignObject',
        {
          y: nodeBaseSize / 2 + labelOffset,
          x: -0.5 * labelWidth,
          width: labelWidth,
          height: '200px',
          style: {
            textAlign: 'center',
            pointerEvents: 'none'
          }
        },
        _react2.default.createElement(
          LabelsStandardContainer,
          null,
          _react2.default.createElement(
            LabelStandard,
            { highlighted: highlighted, contrastMode: contrastMode },
            _react2.default.createElement(_MatchedText2.default, {
              noBorder: true,
              text: label,
              match: this.findFirstSearchMatch(searchTerms, label)
            })
          ),
          !(0, _isEmpty3.default)(labelMinor) && _react2.default.createElement(
            LabelMinorStandard,
            {
              highlighted: highlighted,
              contrastMode: contrastMode
            },
            _react2.default.createElement(_MatchedText2.default, {
              noBorder: true,
              text: labelMinor,
              match: this.findFirstSearchMatch(searchTerms, labelMinor)
            })
          ),
          this.props.renderAppendedInfo()
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var Shape = shapes[this.props.shape];

      return _react2.default.createElement(
        GraphNodeWrapper,
        {
          cursorType: this.props.cursorType,
          onMouseEnter: this.handleMouseEnter,
          onMouseLeave: this.handleMouseLeave,
          onClick: this.handleClick
        },
        this.props.renderPrependedInfo(),
        this.props.forceSvg ? this.renderSvgLabels() : this.renderStandardLabels(),
        _react2.default.createElement(Shape, {
          id: this.props.id,
          size: nodeBaseSize,
          stacked: this.props.stacked,
          color: this.props.color,
          metricColor: this.props.metricColor,
          metricFormattedValue: this.props.metricFormattedValue,
          metricNumericValue: this.props.metricNumericValue,
          highlighted: this.props.highlighted,
          contrastMode: this.props.contrastMode
        })
      );
    }
  }]);

  return GraphNodeStatic;
}(_react2.default.PureComponent);

GraphNodeStatic.propTypes = {
  id: _propTypes2.default.string.isRequired,
  shape: _propTypes2.default.oneOf((0, _keys3.default)(shapes)).isRequired,
  label: _propTypes2.default.string.isRequired,
  labelMinor: _propTypes2.default.string.isRequired,
  labelOffset: _propTypes2.default.number.isRequired,
  stacked: _propTypes2.default.bool.isRequired,
  highlighted: _propTypes2.default.bool.isRequired,
  color: _propTypes2.default.string.isRequired,
  contrastMode: _propTypes2.default.bool.isRequired,
  forceSvg: _propTypes2.default.bool.isRequired,
  metricColor: _propTypes2.default.string.isRequired,
  metricFormattedValue: _propTypes2.default.string.isRequired,
  metricNumericValue: _propTypes2.default.number.isRequired,
  searchTerms: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
  cursorType: _propTypes2.default.string.isRequired,
  renderPrependedInfo: _propTypes2.default.func.isRequired,
  renderAppendedInfo: _propTypes2.default.func.isRequired,
  onMouseEnter: _propTypes2.default.func.isRequired,
  onMouseLeave: _propTypes2.default.func.isRequired,
  onClick: _propTypes2.default.func.isRequired
};

exports.default = GraphNodeStatic;