'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isNumber2 = require('lodash/isNumber');

var _isNumber3 = _interopRequireDefault(_isNumber2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _dom = require('../../../utils/dom');

var _HighlightBorder = require('./elements/_HighlightBorder');

var _HighlightBorder2 = _interopRequireDefault(_HighlightBorder);

var _HighlightShadow = require('./elements/_HighlightShadow');

var _HighlightShadow2 = _interopRequireDefault(_HighlightShadow);

var _NodeBackground = require('./elements/_NodeBackground');

var _NodeBackground2 = _interopRequireDefault(_NodeBackground);

var _NodeMetricFill = require('./elements/_NodeMetricFill');

var _NodeMetricFill2 = _interopRequireDefault(_NodeMetricFill);

var _NodeShadow = require('./elements/_NodeShadow');

var _NodeShadow2 = _interopRequireDefault(_NodeShadow);

var _NodeBorder = require('./elements/_NodeBorder');

var _NodeBorder2 = _interopRequireDefault(_NodeBorder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function getClipPathDefinition(clipId, height, radius) {
  var barHeight = 1 - 2 * height; // in the interval [-1, 1]
  return _react2.default.createElement(
    'defs',
    null,
    _react2.default.createElement(
      'clipPath',
      { id: clipId, transform: 'scale(' + 2 * radius + ')' },
      _react2.default.createElement('rect', { width: 2, height: 2, x: -1, y: barHeight })
    )
  );
}

var NodeAnchor = _styledComponents2.default.circle.attrs({
  strokeWidth: 0.005,
  r: 0.1
}).withConfig({
  displayName: '_BaseShape__NodeAnchor'
})(['fill:', ';stroke:', ';'], function (props) {
  return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple800;
}, function (props) {
  return props.theme.colors.white;
});

var MetricText = _styledComponents2.default.text.attrs({
  transform: 'scale(0.015)',
  dominantBaseline: 'middle',
  textAnchor: 'middle'
}).withConfig({
  displayName: '_BaseShape__MetricText'
})(['fill:', ';'], function (props) {
  return props.contrastMode ? props.theme.colors.black : props.theme.colors.purple800;
});

var BaseShape = function (_React$Component) {
  _inherits(BaseShape, _React$Component);

  function BaseShape() {
    _classCallCheck(this, BaseShape);

    return _possibleConstructorReturn(this, (BaseShape.__proto__ || Object.getPrototypeOf(BaseShape)).apply(this, arguments));
  }

  _createClass(BaseShape, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          renderTemplate = _props.renderTemplate,
          id = _props.id,
          highlighted = _props.highlighted,
          color = _props.color,
          metricColor = _props.metricColor,
          metricFormattedValue = _props.metricFormattedValue,
          metricNumericValue = _props.metricNumericValue,
          contrastMode = _props.contrastMode,
          size = _props.size;


      var clipId = (0, _dom.encodeIdAttribute)('metric-clip-' + id);
      var hasMetric = !(0, _isEmpty3.default)(metricFormattedValue) && (0, _isNumber3.default)(metricNumericValue);

      return _react2.default.createElement(
        'g',
        { transform: 'scale(' + size + ')' },
        highlighted && (0, _HighlightBorder2.default)(renderTemplate, contrastMode),
        highlighted && (0, _HighlightShadow2.default)(renderTemplate, contrastMode),
        (0, _NodeBackground2.default)(renderTemplate, contrastMode),
        hasMetric && getClipPathDefinition(clipId, metricNumericValue, 0.48),
        hasMetric && (0, _NodeMetricFill2.default)(renderTemplate, { clipId: clipId, metricColor: metricColor }),
        (0, _NodeShadow2.default)(renderTemplate, contrastMode),
        (0, _NodeBorder2.default)(renderTemplate, contrastMode, { hasMetric: hasMetric, color: color }),
        hasMetric && highlighted ? _react2.default.createElement(
          MetricText,
          { contrastMode: contrastMode },
          metricFormattedValue
        ) : _react2.default.createElement(NodeAnchor, { contrastMode: contrastMode })
      );
    }
  }]);

  return BaseShape;
}(_react2.default.Component);

BaseShape.propTypes = {
  id: _propTypes2.default.string.isRequired,
  color: _propTypes2.default.string.isRequired,
  size: _propTypes2.default.number.isRequired,
  renderTemplate: _propTypes2.default.func.isRequired,
  highlighted: _propTypes2.default.bool.isRequired,
  metricColor: _propTypes2.default.string.isRequired,
  metricFormattedValue: _propTypes2.default.string.isRequired,
  metricNumericValue: _propTypes2.default.number
};

BaseShape.defaultProps = {
  metricNumericValue: null
};

exports.default = BaseShape;