'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _range2 = require('lodash/range');

var _range3 = _interopRequireDefault(_range2);

exports.curvedUnitPolygonPath = curvedUnitPolygonPath;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d3Shape = require('d3-shape');

var _BaseShape = require('./_BaseShape');

var _BaseShape2 = _interopRequireDefault(_BaseShape);

var _StackedShape = require('./_StackedShape');

var _StackedShape2 = _interopRequireDefault(_StackedShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function curvedUnitPolygonPath(n) {
  var curve = _d3Shape.curveCardinalClosed.tension(0.65);
  var spline = (0, _d3Shape.line)().curve(curve);
  var innerAngle = 2 * (Math.PI / n);
  return spline((0, _range3.default)(0, n).map(function (k) {
    return [Math.sin(k * innerAngle), -Math.cos(k * innerAngle)];
  }));
}

var Shape = function Shape(props) {
  return props.stacked ? _react2.default.createElement(_StackedShape2.default, props) : _react2.default.createElement(_BaseShape2.default, props);
};

exports.default = Shape;