'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GridColumnWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'GridColumn__GridColumnWrapper'
})(['width:', '%;display:block;margin:0.5em;float:left;&:after{display:table;clear:both;content:\'\';}'], function (props) {
  return props.span / 0.12;
});

/**
 * A child of the `<Grid />` component. Used for building layouts.
 *
 * See also [Grid](/components/Grid)
 */
var GridColumn = function GridColumn(_ref) {
  var children = _ref.children,
      span = _ref.span;
  return _react2.default.createElement(
    GridColumnWrapper,
    { className: 'weave-grid-column', span: span },
    children
  );
};

GridColumn.propTypes = {
  /**
   * The desired col-span; maximum of 12 columns
   */
  span: _propTypes2.default.number.isRequired
};

exports.default = GridColumn;