'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var GridRowWrapper = _styledComponents2.default.div.withConfig({
  displayName: 'GridRow__GridRowWrapper'
})(['margin-top:10px;margin-bottom:10px;width:100%;display:flex;flex-direction:row;', ';', ';', ';'], function (props) {
  return props.align === 'left' && 'justify-content: flex-start;';
}, function (props) {
  return props.align === 'right' && 'justify-content: flex-end;';
}, function (props) {
  return props.align === 'center' && 'justify-content: center;';
});

/**
 * A row element that will flex children and align them to the left, center or right.
 */
var GridRow = function GridRow(_ref) {
  var alignContent = _ref.alignContent,
      children = _ref.children;
  return _react2.default.createElement(
    GridRowWrapper,
    { className: 'weave-grid-row', align: alignContent },
    children
  );
};

GridRow.propTypes = {
  /**
   * The direction in which to justify content. Should be 'left', 'center', or 'right';
   */
  alignContent: _propTypes2.default.string.isRequired
};

exports.default = GridRow;