'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Container = _styledComponents2.default.div.withConfig({
  displayName: 'ListItem__Container'
})(['display:flex;position:relative;padding:12px 16px;', ';'], function (props) {
  return props.active && '\n    background-color: ' + props.theme.colors.gray50 + ';\n  ';
});

var Link = Container.withComponent('a');

var Icon = _styledComponents2.default.span.withConfig({
  displayName: 'ListItem__Icon'
})(['margin-right:12px;']);

var Content = _styledComponents2.default.div.withConfig({
  displayName: 'ListItem__Content'
})(['flex-direction:column;width:100%;']);

var Subtext = _styledComponents2.default.span.withConfig({
  displayName: 'ListItem__Subtext'
})(['font-size:', ';opacity:0.5;'], function (props) {
  return props.theme.fontSizes.small;
});

/**
 * A list item component that can be used for or showing off summary details about something!
 *
 * ```javascript
 * export default function ListItemExample({ clickHandler }) {
 *   const onClick = () => clickHandler('onClick', 'clicked it');
 *   return (
 *     <div>
 *       <ListItem
 *         onClick={onClick}
 *         text="Item 1"
 *         />
 *       <ListItem
 *         onClick={onClick}
 *         text="Item 2"
 *         subText="Where do you go to?"
 *         />
 *     </div>
 *   );
 * }
 * ```
 */

var ListItem = function (_React$Component) {
  _inherits(ListItem, _React$Component);

  function ListItem() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, ListItem);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ListItem.__proto__ || Object.getPrototypeOf(ListItem)).call.apply(_ref, [this].concat(args))), _this), _this.handleClick = function (ev) {
      ev.preventDefault();
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          value = _this$props.value;

      if (onClick) {
        onClick(value);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(ListItem, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          text = _props.text,
          subText = _props.subText,
          onClick = _props.onClick,
          children = _props.children,
          style = _props.style,
          leftIcon = _props.leftIcon;

      var BaseTag = onClick ? Link : Container;
      var props = onClick && { href: '#' };
      return _react2.default.createElement(
        BaseTag,
        _extends({
          style: style,
          active: active,
          onClick: this.handleClick
        }, props),
        leftIcon && _react2.default.createElement(
          Icon,
          null,
          leftIcon
        ),
        _react2.default.createElement(
          Content,
          null,
          text && _react2.default.createElement(
            'div',
            null,
            text
          ),
          children,
          subText && _react2.default.createElement(
            Subtext,
            null,
            subText
          )
        )
      );
    }
  }]);

  return ListItem;
}(_react2.default.Component);

ListItem.propTypes = {
  active: _propTypes2.default.bool,
  leftIcon: _propTypes2.default.node,
  onClick: _propTypes2.default.func,
  style: _propTypes2.default.object,
  subText: _propTypes2.default.node,
  text: _propTypes2.default.node,
  value: _propTypes2.default.node
};

ListItem.defaultProps = {
  active: false,
  leftIcon: null,
  onClick: null,
  style: {},
  subText: '',
  text: '',
  value: ''
};

exports.default = ListItem;