'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _max2 = require('lodash/max');

var _max3 = _interopRequireDefault(_max2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _head2 = require('lodash/head');

var _head3 = _interopRequireDefault(_head2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _TimestampTooltip = require('../_TimestampTooltip');

var _TimestampTooltip2 = _interopRequireDefault(_TimestampTooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TooltipRow = _styledComponents2.default.div.withConfig({
  displayName: '_HoverInfo__TooltipRow'
})(['display:flex;align-items:center;justify-content:space-between;font-size:', ';', ';'], function (props) {
  return props.theme.fontSizes.tiny;
}, function (props) {
  return props.focused && '\n    font-weight: bold;\n  ';
});

var TooltipRowColor = _styledComponents2.default.span.withConfig({
  displayName: '_HoverInfo__TooltipRowColor'
})(['background-color:', ';border-radius:', ';margin-right:4px;min-width:10px;height:4px;'], function (props) {
  return props.color;
}, function (props) {
  return props.theme.borderRadius.soft;
});

var TooltipRowName = _styledComponents2.default.span.withConfig({
  displayName: '_HoverInfo__TooltipRowName'
})(['flex-grow:1;white-space:pre;display:block;align-items:center;margin-right:30px;text-overflow:ellipsis;overflow:hidden;']);

var TooltipRowValue = _styledComponents2.default.span.withConfig({
  displayName: '_HoverInfo__TooltipRowValue'
})(['font-family:', ';margin-left:20px;white-space:nowrap;'], function (props) {
  return props.theme.fontFamilies.monospace;
});

var HoverLine = _styledComponents2.default.div.attrs({
  style: function style(_ref) {
    var left = _ref.left,
        height = _ref.height;
    return { left: left, height: height };
  }
}).withConfig({
  displayName: '_HoverInfo__HoverLine'
})(['border-left:1px solid ', ';pointer-events:none;position:absolute;top:0;'], function (props) {
  return props.theme.colors.gray600;
});

var FocusPoint = _styledComponents2.default.span.attrs({
  style: function style(_ref2) {
    var top = _ref2.top;
    return { top: top };
  }
}).withConfig({
  displayName: '_HoverInfo__FocusPoint'
})(['border:2.5px solid ', ';border-radius:', ';background-color:', ';opacity:', ';box-sizing:border-box;position:absolute;cursor:default;pointer-events:none;', ';'], function (props) {
  return props.color;
}, function (props) {
  return props.theme.borderRadius.circle;
}, function (props) {
  return props.theme.colors.white;
}, function (props) {
  return props.faded ? 0.5 : 1;
}, function (props) {
  return '\n    margin-left: ' + -props.radius + 'px;\n    margin-top: ' + -props.radius + 'px;\n    width: ' + 2 * props.radius + 'px;\n    height: ' + 2 * props.radius + 'px;\n  ';
});

var HoverInfo = function (_React$PureComponent) {
  _inherits(HoverInfo, _React$PureComponent);

  function HoverInfo() {
    _classCallCheck(this, HoverInfo);

    return _possibleConstructorReturn(this, (HoverInfo.__proto__ || Object.getPrototypeOf(HoverInfo)).apply(this, arguments));
  }

  _createClass(HoverInfo, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          datapoints = _props.datapoints,
          mouseX = _props.mouseX,
          mouseY = _props.mouseY,
          valueScale = _props.valueScale,
          chartWidth = _props.chartWidth,
          chartHeight = _props.chartHeight,
          simpleTooltip = _props.simpleTooltip;

      if (!datapoints) return null;

      // Simple tooltip will only show the value for the hovered series.
      var filteredHoverPoints = [].concat(_toConsumableArray(datapoints)).filter(function (p) {
        return p.focused || !simpleTooltip;
      });

      // Render focused circle last so that it stands out.
      var sortedHoverPoints = [].concat(_toConsumableArray(filteredHoverPoints)).sort(function (p) {
        return p.focused ? 1 : -1;
      });

      var timestamp = _moment2.default.unix(this.props.timestampSec).format();

      // We want to have same formatting (precision, units, etc...) across
      // all tooltip values so we create a formatter for a reference value
      // (1 / 10 of the max value) and use it across all datapoints.
      var referenceValue = ((0, _max3.default)((0, _map3.default)(datapoints, 'value')) || 0) / 10;
      var formatValue = this.props.valueFormatter(referenceValue);

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(
          HoverLine,
          { left: mouseX, height: chartHeight },
          sortedHoverPoints.map(function (datapoint) {
            return _react2.default.createElement(FocusPoint, {
              key: datapoint.key,
              color: datapoint.color,
              faded: !datapoint.focused,
              radius: datapoint.focused ? 5 : 4,
              top: valueScale(datapoint.graphValue)
            });
          })
        ),
        _react2.default.createElement(
          _TimestampTooltip2.default,
          {
            offsetX: mouseX,
            offsetY: mouseY,
            containerWidth: chartWidth,
            timestamp: timestamp
          },
          filteredHoverPoints.map(function (datapoint) {
            return _react2.default.createElement(
              TooltipRow,
              { key: datapoint.key, focused: datapoint.focused },
              _react2.default.createElement(TooltipRowColor, { color: datapoint.color }),
              _react2.default.createElement(
                TooltipRowName,
                null,
                (0, _head3.default)(datapoint.hoverName)
              ),
              _react2.default.createElement(
                TooltipRowValue,
                null,
                formatValue(datapoint.value)
              )
            );
          })
        )
      );
    }
  }]);

  return HoverInfo;
}(_react2.default.PureComponent);

HoverInfo.propTypes = {
  chartWidth: _propTypes2.default.number.isRequired,
  chartHeight: _propTypes2.default.number.isRequired,
  valueScale: _propTypes2.default.func.isRequired,
  valueFormatter: _propTypes2.default.func.isRequired,
  simpleTooltip: _propTypes2.default.bool.isRequired,
  datapoints: _propTypes2.default.array,
  timestampSec: _propTypes2.default.number.isRequired,
  mouseX: _propTypes2.default.number,
  mouseY: _propTypes2.default.number
};

HoverInfo.defaultProps = {
  datapoints: [],
  mouseX: 0,
  mouseY: 0
};

exports.default = HoverInfo;