'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _noop2 = require('lodash/noop');

var _noop3 = _interopRequireDefault(_noop2);

var _last2 = require('lodash/last');

var _last3 = _interopRequireDefault(_last2);

var _debounce2 = require('lodash/debounce');

var _debounce3 = _interopRequireDefault(_debounce2);

var _isEmpty2 = require('lodash/isEmpty');

var _isEmpty3 = _interopRequireDefault(_isEmpty2);

var _includes2 = require('lodash/includes');

var _includes3 = _interopRequireDefault(_includes2);

var _without2 = require('lodash/without');

var _without3 = _interopRequireDefault(_without2);

var _concat2 = require('lodash/concat');

var _concat3 = _interopRequireDefault(_concat2);

var _map2 = require('lodash/map');

var _map3 = _interopRequireDefault(_map2);

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _compose = require('../../utils/compose');

var _Input = require('../Input');

var _Input2 = _interopRequireDefault(_Input);

var _Dropdown = require('../Dropdown');

var _Dropdown2 = _interopRequireDefault(_Dropdown);

var _SearchTerm = require('./_SearchTerm');

var _SearchTerm2 = _interopRequireDefault(_SearchTerm);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Don't make functions async if we are running tests
var timeout = function timeout(cb, t) {
  if (process.env.NODE_ENV === 'test') {
    return cb;
  }

  return (0, _debounce3.default)(cb, t);
};

var TermsContainer = _styledComponents2.default.ul.withConfig({
  displayName: 'Search__TermsContainer'
})(['list-style:none;display:flex;margin:0;padding:0;flex-wrap:wrap;']);

var Icon = _styledComponents2.default.i.withConfig({
  displayName: 'Search__Icon'
})(['line-height:34px;padding:0 8px;']);

var SearchInput = _styledComponents2.default.div.withConfig({
  displayName: 'Search__SearchInput'
})(['display:flex;flex-wrap:wrap;flex:3;width:100%;']);

var Styled = function Styled(component) {
  return (0, _styledComponents2.default)(component).withConfig({
    displayName: 'Search'
  })(['position:relative;display:flex;background-color:', ';border:1px solid ', ';border-radius:', ';div,input{border:0;}', ',', '{padding:0;margin:0;}', '{flex:1;border-left:1px solid ', ';}', '{flex:2;width:100%;input{padding:0 8px;width:100%;}input:focus{outline:none;}div{margin:0;}}'], function (props) {
    return props.theme.colors.white;
  }, function (props) {
    return props.theme.colors.purple100;
  }, function (props) {
    return props.theme.borderRadius.soft;
  }, _Input2.default, _Dropdown2.default, _Dropdown2.default, function (props) {
    return props.theme.colors.gray200;
  }, _Input2.default);
};

var Search = function (_React$PureComponent) {
  _inherits(Search, _React$PureComponent);

  function Search(props, context) {
    _classCallCheck(this, Search);

    var _this = _possibleConstructorReturn(this, (Search.__proto__ || Object.getPrototypeOf(Search)).call(this, props, context));

    _this.state = {
      text: _this.props.initialQuery,
      terms: _this.props.initialPinnedTerms
    };

    _this.addSearchTerm = function (ev, value) {
      if (!(0, _includes3.default)(_this.state.terms, value)) {
        // only push unique values
        _this.setState({ terms: _concat3.default.apply(undefined, _toConsumableArray(_this.state.terms).concat([value])) }, _this.doPinSearchTerm);
      }
      _this.setState({ text: '' }, _this.doSearch);
    };

    _this.removeSearchTerm = function (value) {
      var terms = (0, _without3.default)(_this.state.terms, value);
      _this.setState({ terms: terms }, _this.doPinSearchTerm);
    };

    _this.handleInputKeyPress = function (ev) {
      if (ev.key === 'Enter' && _this.state.text.length > 0) {
        ev.preventDefault();
        _this.addSearchTerm(ev, _this.state.text);
      }

      if (ev.key === 'Backspace' && _this.state.text === '') {
        ev.preventDefault();
        var term = (0, _last3.default)(_this.state.terms);
        if (term) {
          // Allow the user to edit the text of the last term instead of removing the whole thing.
          _this.setState({ text: term }, function () {
            return _this.removeSearchTerm(term);
          });
        }
      }
    };

    _this.handleInputChange = function (ev) {
      _this.setState({ text: ev.target.value }, _this.doSearch);
    };

    _this.handleInputBlur = function (ev) {
      // If the input loses focus, pin the search term. Skip if input is empty.
      if (_this.state.text) {
        _this.addSearchTerm(ev, _this.state.text);
      }
      _this.props.onBlur(ev);
    };

    _this.handleFilterChange = function (ev, value) {
      _this.input.focus();
      _this.addSearchTerm(ev, value);
    };

    _this.doSearch = timeout(_this.doSearch.bind(_this), 200);
    return _this;
  }

  _createClass(Search, [{
    key: 'doPinSearchTerm',
    value: function doPinSearchTerm() {
      this.props.onChange(this.state.text, this.state.terms);
      this.props.onPin(this.state.terms);
    }
  }, {
    key: 'doSearch',
    value: function doSearch() {
      this.props.onChange(this.state.text, this.state.terms);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          filters = _props.filters,
          placeholder = _props.placeholder;
      var _state = this.state,
          terms = _state.terms,
          text = _state.text;


      return _react2.default.createElement(
        'div',
        { className: className },
        _react2.default.createElement(Icon, { className: 'fa fa-search' }),
        _react2.default.createElement(
          SearchInput,
          null,
          _react2.default.createElement(
            TermsContainer,
            null,
            (0, _map3.default)(terms, function (term) {
              return _react2.default.createElement(_SearchTerm2.default, { key: term, term: term, onRemove: _this2.removeSearchTerm });
            })
          ),
          _react2.default.createElement(_Input2.default, {
            hideValidationMessage: true,
            onChange: this.handleInputChange,
            value: text,
            onKeyDown: this.handleInputKeyPress,
            onBlur: this.handleInputBlur,
            onFocus: this.props.onFocus,
            inputRef: function inputRef(ref) {
              _this2.input = ref;
            },
            placeholder: terms.length === 0 ? placeholder : null
          })
        ),
        !(0, _isEmpty3.default)(filters) && _react2.default.createElement(_Dropdown2.default, {
          items: filters,
          placeholder: 'Filters',
          onChange: this.handleFilterChange
        })
      );
    }
  }]);

  return Search;
}(_react2.default.PureComponent);

Search.propTypes = {
  /**
   * The initial value to use to populate the search text field.
   * Changes to this prop will be ignored after initial render.
   */
  initialQuery: _propTypes2.default.string,
  /**
   * The initial pinned terms of the search field.
   * Changes to this prop will be ignored after initial render.
   */
  initialPinnedTerms: _propTypes2.default.arrayOf(_propTypes2.default.string),
  /**
   * A list of selectable filters to be rendered in a `<Dropdown />`.
   * When an option is clicked, the `value` is added to the search terms.
   * This array will be passed directly to the `items` prop of the `<Dropdown />.
   * If omitted, no dropdown will be rendered.
   */
  filters: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    value: _propTypes2.default.string,
    label: _propTypes2.default.string
  })),
  /**
   * Text that will be passed to the search input as the placeholder.
   */
  placeholder: _propTypes2.default.string,
  /**
   * Handler that runs when the text input changes.
   * Returns the text as first argument, and the list of pinned terms as the second.
   */
  onChange: _propTypes2.default.func,
  /**
   * Handler that runs when a search is pinned or unpinned.
   * Returns an array of the currently pinned terms.
   */
  onPin: _propTypes2.default.func,
  onFocus: _propTypes2.default.func,
  onBlur: _propTypes2.default.func
};

Search.defaultProps = {
  filters: [],
  initialQuery: '',
  initialPinnedTerms: [],
  placeholder: '',
  onPin: _noop3.default,
  onChange: _noop3.default,
  onFocus: _noop3.default,
  onBlur: _noop3.default
};

exports.default = (0, _compose.copyPropTypes)(Search, Styled(Search));