'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _moment = require('moment');

var _moment2 = _interopRequireDefault(_moment);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _styledComponents = require('styled-components');

var _styledComponents2 = _interopRequireDefault(_styledComponents);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TimelineLabelWrapper = _styledComponents2.default.span.attrs({
  style: function style(_ref) {
    var x = _ref.x;
    return { transform: 'translateX(' + x + 'px)' };
  }
}).withConfig({
  displayName: '_TimelineLabel__TimelineLabelWrapper'
})(['position:absolute;']);

var TimelineLabelLine = _styledComponents2.default.span.withConfig({
  displayName: '_TimelineLabel__TimelineLabelLine'
})(['border-left:1px solid ', ';height:75px;'], function (props) {
  return props.theme.colors.gray200;
});

var TimelineLabelContainer = _styledComponents2.default.button.withConfig({
  displayName: '_TimelineLabel__TimelineLabelContainer'
})(['background-color:transparent;color:', ';font-size:', ';cursor:pointer;pointer-events:all;margin-left:2px;padding:0 1px;outline:0;border:0;&::-moz-focus-inner{border:0;}&:focus{outline:none;}&[disabled]{color:', ';cursor:inherit;}&:not([disabled]):hover{color:', ';}'], function (props) {
  return props.theme.colors.purple400;
}, function (props) {
  return props.theme.fontSizes.small;
}, function (props) {
  return props.theme.colors.gray600;
}, function (props) {
  return props.theme.colors.purple900;
});

var TimelineLabel = function (_React$Component) {
  _inherits(TimelineLabel, _React$Component);

  function TimelineLabel() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, TimelineLabel);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = TimelineLabel.__proto__ || Object.getPrototypeOf(TimelineLabel)).call.apply(_ref2, [this].concat(args))), _this), _this.handleClick = function () {
      if (!_this.props.disabled) {
        _this.props.onClick(_this.props.timestamp);
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TimelineLabel, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          periodFormat = _props.periodFormat,
          timestamp = _props.timestamp,
          position = _props.position,
          isBehind = _props.isBehind,
          disabled = _props.disabled;


      return _react2.default.createElement(
        TimelineLabelWrapper,
        { x: position },
        !isBehind && _react2.default.createElement(TimelineLabelLine, null),
        _react2.default.createElement(
          TimelineLabelContainer,
          {
            onClick: this.handleClick,
            title: disabled ? '' : 'Jump to ' + timestamp,
            disabled: disabled
          },
          (0, _moment2.default)(timestamp).utc().format(periodFormat)
        )
      );
    }
  }]);

  return TimelineLabel;
}(_react2.default.Component);

TimelineLabel.propTypes = {
  periodFormat: _propTypes2.default.string.isRequired,
  timestamp: _propTypes2.default.string.isRequired,
  position: _propTypes2.default.number.isRequired,
  onClick: _propTypes2.default.func.isRequired,
  disabled: _propTypes2.default.bool,
  isBehind: _propTypes2.default.bool
};

TimelineLabel.defaultProps = {
  disabled: false,
  isBehind: false
};

exports.default = TimelineLabel;